#include <nitro.h>
#include "init.h"
#include "vct.h"


#define ROUND(n, a)		(((u32)(n)+(a)-1) & ~((a)-1))

static OSHeapHandle sHandle;

u8 gAudioBuffer[VCT_AUDIO_BUFFER_SIZE * VCT_DEFAULT_AUDIO_BUFFER_COUNT *
                VCT_MAX_AUDIO_STREAM] ATTRIBUTE_ALIGN(32);

void Heap_Init(void)
{
	void*    arenaLo;
	void*    arenaHi;
	
	// [nakata] Prepare heap memory
    arenaLo = OS_GetArenaLo(OS_ARENA_MAIN);
    arenaHi = OS_GetArenaHi(OS_ARENA_MAIN);

    arenaLo = OS_InitAlloc(OS_ARENA_MAIN, arenaLo, arenaHi, 1);
    OS_SetArenaLo(OS_ARENA_MAIN, arenaLo);

    // [nakata] Align pointer to 32-bit boundary
    arenaLo = (void*)ROUND(arenaLo, 32);
    arenaHi = (void*)ROUND(arenaHi, 32);

    // [nakata] Create heap memory
    sHandle = OS_CreateHeap(OS_ARENA_MAIN, arenaLo, arenaHi);
    OS_SetCurrentHeap(OS_ARENA_MAIN, sHandle );

    // From here on out, OS_Alloc and OS_Free behave like malloc and free respectively
    OS_SetArenaLo(OS_ARENA_MAIN, arenaHi);
}

void Heap_Dump( void )
{
    OS_DumpHeap( OS_ARENA_MAIN, sHandle );
}

void Alarm_Init(void)
{
	// [nakata] Initialization required in order to use infrastructure mode
	OS_InitTick();
	OS_InitAlarm();
	PXI_InitFifo();
}
